## kuserfeedback 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(KUserFeedback VERSION 1.0.0)

set(POLICY CMP0048 NEW)
if(POLICY CMP0053)
    cmake_policy(SET CMP0053 NEW)
endif()
if(POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()
find_package(ECM 5.26 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})

set(ENABLE_SURVEY_TARGET_EXPRESSIONS ON CACHE BOOL "Survey targeting expressions support is enabled by default.")
set(ENABLE_PHP                       ON CACHE BOOL "Syntax checking of PHP server code.")
set(ENABLE_PHP_UNIT                  ON CACHE BOOL "Unit tests for PHP server code.")
set(ENABLE_DOCS                      ON CACHE BOOL "Generate documentation.")
set(ENABLE_CONSOLE                   ON CACHE BOOL "Application console.")
set(ENABLE_CLI                       ON CACHE BOOL "Command line interface support.")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMGenerateHeaders)
include(ECMPoQmTools)
include(ECMSetupVersion)
include(ECMQueryQmake)
include(ECMGeneratePriFile)
include(FeatureSummary)
include(GenerateExportHeader)

ecm_setup_version(PROJECT
    VARIABLE_PREFIX KUSERFEEDBACK
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kuserfeedback_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KUserFeedbackConfigVersion.cmake"
)
#
# Dependencies
#

find_package(Qt5 5.4 NO_MODULE REQUIRED COMPONENTS Core Network)
find_package(Qt5 NO_MODULE QUIET OPTIONAL_COMPONENTS Widgets Charts Test Qml Svg PrintSupport)
find_package(QmlLint)
if (NOT CMAKE_CROSSCOMPILING)
    find_package(Qt5 NO_MODULE QUIET OPTIONAL_COMPONENTS Help)
endif()

set_package_properties(Qt5 PROPERTIES URL "http://qt-project.org/")
set_package_properties(Qt5Widgets PROPERTIES TYPE RECOMMENDED PURPOSE "Required for feedback configuration and notification widgets.")
set_package_properties(Qt5Charts PROPERTIES TYPE RECOMMENDED PURPOSE "Required for UserFeedbackConsole.")

# debug suffixes for qmake compatibility
if(WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
elseif(APPLE)
    set(CMAKE_DEBUG_POSTFIX "_debug")
endif()

add_definitions(-DQT_USE_QSTRINGBUILDER -DQT_USE_FAST_OPERATOR_PLUS -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING -DQT_NO_CAST_FROM_ASCII)

if (ENABLE_SURVEY_TARGET_EXPRESSIONS)
    find_package(FLEX)
    set_package_properties(FLEX PROPERTIES TYPE RECOMMENDED PURPOSE "Survey target expression parser.")

    find_package(BISON)
    set_package_properties(BISON PROPERTIES TYPE RECOMMENDED PURPOSE "Survey target expression parser.")

    if(FLEX_FOUND AND BISON_FOUND)
        set(HAVE_SURVEY_TARGET_EXPRESSIONS 1)
    endif()
endif()
add_feature_info("Survey targeting expressions support" HAVE_SURVEY_TARGET_EXPRESSIONS "Requires flex and bison parser generators.")

if (ENABLE_PHP)
    find_package(Php)
    set_package_properties(Php PROPERTIES URL "http://php.net" TYPE RECOMMENDED PURPOSE "Syntax checking of PHP server code.")
endif()

if (ENABLE_PHP_UNIT)
    find_package(PhpUnit)
    set_package_properties(PhpUnit PROPERTIES URL "http://phpunit.de" TYPE RECOMMENDED PURPOSE "Unit tests for PHP server code.")
endif()

#
# Actually build the stuff
#
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})
configure_file(config-userfeedback.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-userfeedback.h)

add_subdirectory(src)

if (BUILD_TESTING)
    add_subdirectory(autotests)

    add_subdirectory(tests)
endif()

if (ENABLE_DOCS)
    add_subdirectory(docs)
endif()

#
# CMake package config file generation
#
include(CMakePackageConfigHelpers)
configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/KUserFeedbackConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedbackConfig.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback
    PATH_VARS KDE_INSTALL_INCLUDEDIR
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedbackConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedbackConfigVersion.cmake
    DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback
)

install(EXPORT KUserFeedbackTargets DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback FILE KUserFeedbackTarget.cmake)
install(FILES org_kde_UserFeedback.categories DESTINATION ${KDE_INSTALL_CONFDIR})

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

ecm_install_po_files_as_qm(po)

=== autotests/CMakeLists.txt ===
configure_file(test-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/test-config.h)
if(TARGET KUserFeedbackConsole)
add_library(KUserFeedbackTestUtils STATIC
    servercontroller.cpp
)
target_link_libraries(KUserFeedbackTestUtils LINK_PUBLIC Qt5::Test KUserFeedbackConsole)
endif()

function(uf_add_test _file)
    get_filename_component(_name ${_file} NAME_WE)
    add_executable(${_name} ${_file})
    target_link_libraries(${_name} Qt5::Test ${ARGN})
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

uf_add_test(datasourcetest KUserFeedbackCore Qt5::Gui) # needs Gui for ScreenInfoSource to work
uf_add_test(openglinfosourcetest.cpp KUserFeedbackCore Qt5::Gui)
uf_add_test(providertest KUserFeedbackCore Qt5::Gui)
uf_add_test(selectionratiosourcetest.cpp KUserFeedbackCore Qt5::Gui)
uf_add_test(surveyprovidertest.cpp KUserFeedbackCore)

uf_add_test(feedbackconfigtest KUserFeedbackWidgets)

if(HAVE_SURVEY_TARGET_EXPRESSIONS)
    uf_add_test(surveytargetexpressiontest.cpp KUserFeedbackCommon)
endif()

if(TARGET KUserFeedbackConsole)
    uf_add_test(producttest KUserFeedbackConsole)
    uf_add_test(schematemplatetest.cpp KUserFeedbackConsole)
    uf_add_test(sampletest KUserFeedbackConsole)
    uf_add_test(serverinfotest.cpp KUserFeedbackConsole)

    uf_add_test(schemamodeltest KUserFeedbackTestUtils)
    uf_add_test(datamodeltest KUserFeedbackTestUtils)
    uf_add_test(timeaggregationmodeltest KUserFeedbackTestUtils)
    uf_add_test(categoryaggregationmodeltest KUserFeedbackTestUtils)
    uf_add_test(numericaggregationmodeltest KUserFeedbackTestUtils)
    uf_add_test(ratiosetaggregationmodeltest KUserFeedbackTestUtils)
endif()

if(ENABLE_PHP)
    list(FIND PHP_MODULES "PDO" _has_pdo)
    if(TARGET KUserFeedbackConsole AND _has_pdo GREATER -1)
        uf_add_test(productapitest KUserFeedbackTestUtils)
        uf_add_test(productmodeltest KUserFeedbackTestUtils)
        uf_add_test(surveyapitest KUserFeedbackTestUtils)
        uf_add_test(submittest KUserFeedbackTestUtils KUserFeedbackCore Qt5::Gui)
    endif()

    set(php_test_srcs
        utilstest.php
        schemaentrytest.php
        schemaentryelementtest.php
        producttest.php
        sampletest.php
        surveytest.php
        aggregationtest.php
    )

    php_lint(abstractdatastoretest.php)
    php_lint(${php_test_srcs})
    if(PhpUnit_FOUND)
        foreach(_php_test ${php_test_srcs})
            add_test(NAME ${_php_test} COMMAND ${PHPUNIT_EXECUTABLE} ${_php_test} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
        endforeach()
    endif()
endif()

=== docs/CMakeLists.txt ===
query_qmake(QT_INSTALL_DOCS "QT_INSTALL_DOCS")
query_qmake(QT_INSTALL_DATA "QT_INSTALL_DATA")
query_qmake(QT_INSTALL_BINS "QT_INSTALL_BINS")

find_program(QDOC_EXECUTABLE qdoc HINTS ${QT_INSTALL_BINS})

find_file(QDOC_TEMPLATE global/qt-html-templates-offline.qdocconf
  HINTS ${QT_INSTALL_DOCS}
  HINTS ${QT_INSTALL_DATA}
  HINTS ${QT_INSTALL_DATA}/doc
)
get_filename_component(QDOC_TEMPLATE_DIR ${QDOC_TEMPLATE} DIRECTORY)

if(NOT QDOC_EXECUTABLE OR NOT TARGET Qt5::qhelpgenerator OR NOT TARGET Qt5::qcollectiongenerator OR NOT QDOC_TEMPLATE_DIR)
  message(STATUS "Unable to build user manual:")
  message(STATUS "qdoc exectuable: ${QDOC_EXECUTABLE}")
  if(TARGET Qt5::qhelpgenerator)
    get_property(_path TARGET Qt5::qhelpgenerator PROPERTY LOCATION)
    message(STATUS "qhelpgenerator exectuable: ${_path}")
  else()
    message(STATUS "qhelpgenerator not found")
  endif()
  if(TARGET Qt5::qcollectiongenerator)
    get_property(_path TARGET Qt5::qcollectiongenerator PROPERTY LOCATION)
    message(STATUS "qcollectiongenerator exectuable: ${_path}")
  else()
    message(STATUS "qcollectiongenerator not found")
  endif()
  message(STATUS "qdoc template direectory: ${QDOC_TEMPLATE_DIR}")
  return()
endif()

# build .qch
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/user-feedback-manual.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/user-feedback-manual.qdocconf)
file(GLOB_RECURSE _qdoc_srcs ${CMAKE_CURRENT_SOURCE_DIR} "*.qdoc")
set(_qdoc_output_dir ${CMAKE_CURRENT_BINARY_DIR}/manual)
add_custom_command(
    OUTPUT ${_qdoc_output_dir}/user-feedback-manual.qhp
    COMMAND ${QDOC_EXECUTABLE}
        --outputdir ${_qdoc_output_dir}
        ${CMAKE_CURRENT_BINARY_DIR}/user-feedback-manual.qdocconf
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/user-feedback-manual.qdocconf ${_qdoc_srcs}
)
add_custom_command(
    OUTPUT ${_qdoc_output_dir}/user-feedback-manual.qch
    COMMAND Qt5::qhelpgenerator ${_qdoc_output_dir}/user-feedback-manual.qhp
    DEPENDS ${_qdoc_output_dir}/user-feedback-manual.qhp
)
add_custom_target(user_feedback_manual_qch ALL DEPENDS ${_qdoc_output_dir}/user-feedback-manual.qch)
install(FILES ${_qdoc_output_dir}/user-feedback-manual.qch DESTINATION ${KDE_INSTALL_DATAROOTDIR}/KDE/UserFeedbackConsole)

# build .qhc
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/user-feedback.qhcp.in ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhcp)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/manual/user-feedback-manual.qch ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND Qt5::qcollectiongenerator ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhcp -o ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc
    DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhcp
        user_feedback_manual_qch
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
add_custom_target(user_feedback_qhc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc DESTINATION ${KDE_INSTALL_DATAROOTDIR}/KDE/UserFeedbackConsole)

=== src/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(provider)

if (ENABLE_PHP AND ENABLE_PHP_UNIT)
    add_subdirectory(server)
    add_subdirectory(testserver)
endif()

list(FIND CMAKE_CXX_COMPILE_FEATURES cxx_generic_lambdas has_generic_lambdas)
if(Qt5Charts_FOUND AND Qt5Svg_FOUND AND Qt5PrintSupport_FOUND AND NOT has_generic_lambdas LESS 0 AND NOT Qt5Core_VERSION VERSION_LESS 5.8)
    if (ENABLE_CONSOLE)
        add_subdirectory(console)
    endif()

    if (ENABLE_CLI)
        add_subdirectory(cli)
    endif()
endif()

=== tests/CMakeLists.txt ===
if(TARGET KUserFeedbackWidgets AND NOT (CMAKE_SOURCE_DIR EQUAL CMAKE_CURRENT_SOURCE_DIR))
    add_executable(feedbackconfigwidgettest feedbackconfigwidgettest.cpp)
    target_link_libraries(feedbackconfigwidgettest KUserFeedbackWidgets)

    add_executable(notificationpopuptest notificationpopuptest.cpp)
    target_link_libraries(notificationpopuptest KUserFeedbackWidgets)

    add_executable(orwell orwell.cpp)
    target_link_libraries(orwell KUserFeedbackWidgets)

    qml_lint(orwell.qml)
else()
    # stand-alone build for testing includes and cmake config
    message(STATUS "building test application stand-alone")
    set(CMAKE_AUTOMOC ON)
    set(CMAKE_AUTOUIC ON)
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
    find_package(KUserFeedback REQUIRED)
    add_executable(orwell orwell.cpp)
    target_link_libraries(orwell KUserFeedbackWidgets)
endif()

=== src/common/CMakeLists.txt ===
set(common_src
    surveytargetexpression.cpp
    surveytargetexpressionevaluator.cpp
    surveytargetexpressionparser.cpp
)

if(HAVE_SURVEY_TARGET_EXPRESSIONS)

if (CMAKE_VERSION VERSION_LESS 3.5.0)
    set(_flex_opts COMPILE_FLAGS --header-file=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
    set(_bison_opts COMPILE_FLAGS --defines=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.h)
else()
    set(_flex_opts DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
    set(_bison_opts DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.h)
endif()

flex_target(surveytargetexpressionscanner
    surveytargetexpressionlexer.l
    ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionlexer.cpp
    ${_flex_opts}
)
bison_target(surveytargetexpressionparser
    surveytargetexpressionparser.y
    ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.cpp
    ${_bison_opts}
)
add_flex_bison_dependency(surveytargetexpressionscanner surveytargetexpressionparser)
endif()

add_library(KUserFeedbackCommon STATIC
    ${common_src}
    ${BISON_surveytargetexpressionparser_OUTPUTS}
    ${FLEX_surveytargetexpressionscanner_OUTPUTS}
)

if (NOT BUILD_SHARED_LIBS)
    install(TARGETS KUserFeedbackCommon
            EXPORT KUserFeedbackTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

target_include_directories(KUserFeedbackCommon PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..>")
target_link_libraries(KUserFeedbackCommon LINK_PRIVATE Qt5::Core)

=== src/console/CMakeLists.txt ===
ecm_create_qm_loader(userfeedback_console_QM_LOADER userfeedbackconsole5_qt)

set(console_lib_srcs
    core/aggregation.cpp
    core/aggregationelement.cpp
    core/product.cpp
    core/sample.cpp
    core/schemaentry.cpp
    core/schemaentryelement.cpp
    core/schemaentrytemplates.cpp
    core/survey.cpp

    rest/restapi.cpp
    rest/restclient.cpp
    rest/serverinfo.cpp

    jobs/job.cpp
    jobs/handshakejob.cpp
    jobs/productexportjob.cpp
    jobs/productimportjob.cpp
    jobs/securityscanjob.cpp

    model/aggregateddatamodel.cpp
    model/aggregationeditormodel.cpp
    model/aggregationelementmodel.cpp
    model/aggregationelementeditmodel.cpp
    model/categoryaggregationmodel.cpp
    model/datamodel.cpp
    model/extrarowsproxymodel.cpp
    model/numericaggregationmodel.cpp
    model/productmodel.cpp
    model/ratiosetaggregationmodel.cpp
    model/rolemappingproxymodel.cpp
    model/schemamodel.cpp
    model/singlerowfilterproxymodel.cpp
    model/surveymodel.cpp
    model/timeaggregationmodel.cpp

    schematemplates/schematemplates.qrc
)

add_library(KUserFeedbackConsole STATIC ${console_lib_srcs})
target_link_libraries(KUserFeedbackConsole Qt5::Network)
target_include_directories(KUserFeedbackConsole PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..>")
target_compile_features(KUserFeedbackConsole PRIVATE cxx_generic_lambdas)
target_compile_definitions(KUserFeedbackConsole PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x050600 QT_DEPRECATED_WARNINGS)

if(NOT TARGET KUserFeedbackWidgets)
    return()
endif()

set(console_srcs
    connectdialog.cpp
    main.cpp
    mainwindow.cpp
    helpcontroller.cpp

    analytics/aggregator.cpp
    analytics/analyticsview.cpp
    analytics/categoryaggregator.cpp
    analytics/chartexportdialog.cpp
    analytics/chartutil.cpp
    analytics/numericaggregator.cpp
    analytics/ratiosetaggregator.cpp
    analytics/totalaggregator.cpp

    schemaeditor/aggregationeditwidget.cpp
    schemaeditor/schemaeditor.cpp
    schemaeditor/schemaeditwidget.cpp
    schemaeditor/schemaentryitemeditorfactory.cpp

    surveyeditor/surveydialog.cpp
    surveyeditor/surveyeditor.cpp

    widgets/metaenumcombobox.cpp

    ${userfeedback_console_QM_LOADER}
)

add_executable(KUserFeedbackConsoleApplication ${console_srcs})
target_compile_features(KUserFeedbackConsoleApplication PRIVATE cxx_generic_lambdas)
set_target_properties(KUserFeedbackConsoleApplication PROPERTIES OUTPUT_NAME UserFeedbackConsole)
target_link_libraries(KUserFeedbackConsoleApplication
    Qt5::Widgets
    Qt5::Network
    Qt5::Charts
    Qt5::PrintSupport
    Qt5::Svg
    KUserFeedbackWidgets
    KUserFeedbackConsole
    KUserFeedbackCommon
)

install(TARGETS KUserFeedbackConsoleApplication ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
if(UNIX AND NOT APPLE)
    install(FILES UserFeedbackConsole.desktop DESTINATION ${KDE_INSTALL_APPDIR})
endif()

=== src/provider/CMakeLists.txt ===
include(KDEFrameworkCompilerSettings)
add_subdirectory(core)
if(TARGET Qt5::Widgets)
  add_subdirectory(widgets)
endif()
if(TARGET Qt5::Qml)
  add_subdirectory(qml)
endif()

=== src/provider/core/CMakeLists.txt ===
ecm_create_qm_loader(userfeedback_core_QM_LOADER userfeedbackprovider5_qt)

set(userfeedback_core_srcs
    abstractdatasource.cpp
    applicationversionsource.cpp
    compilerinfosource.cpp
    cpuinfosource.cpp
    feedbackconfiguicontroller.cpp
    localeinfosource.cpp
    openglinfosource.cpp
    platforminfosource.cpp
    propertyratiosource.cpp
    provider.cpp
    qpainfosource.cpp
    qtversionsource.cpp
    screeninfosource.cpp
    selectionratiosource.cpp
    startcountsource.cpp
    surveyinfo.cpp
    usagetimesource.cpp
    auditloguicontroller.cpp
    ${userfeedback_core_QM_LOADER}
)

add_library(KUserFeedbackCore ${userfeedback_core_srcs})
set_target_properties(KUserFeedbackCore PROPERTIES
    SOVERSION ${KUSERFEEDBACK_SOVERSION}
    VERSION ${KUSERFEEDBACK_VERSION_STRING}
)
generate_export_header(KUserFeedbackCore)

target_link_libraries(KUserFeedbackCore PUBLIC Qt5::Core PRIVATE Qt5::Gui Qt5::Network)
if(ANDROID)
    target_link_libraries(KUserFeedbackCore PRIVATE GLESv2)
endif()
target_compile_definitions(KUserFeedbackCore PRIVATE QT_DISABLE_DEPRECATED_BEFORE=0x050300)
target_link_libraries(KUserFeedbackCore PRIVATE KUserFeedbackCommon)
target_include_directories(KUserFeedbackCore PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR}>")
target_include_directories(KUserFeedbackCore INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KUserFeedback;${KDE_INSTALL_INCLUDEDIR}>")

ecm_generate_headers(KUserFeedbackCore_HEADERS
    HEADER_NAMES
        AbstractDataSource
        ApplicationVersionSource
        CompilerInfoSource
        CpuInfoSource
        LocaleInfoSource
        OpenGLInfoSource
        PlatformInfoSource
        PropertyRatioSource
        Provider
        QPAInfoSource
        QtVersionSource
        ScreenInfoSource
        StartCountSource
        SurveyInfo
        UsageTimeSource
        FeedbackConfigUiController
    REQUIRED_HEADERS KUserFeedbackCore_HEADERS
)

install(TARGETS KUserFeedbackCore EXPORT KUserFeedbackTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
    ${KUserFeedbackCore_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/kuserfeedbackcore_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KUserFeedback
)

ecm_generate_pri_file(BASE_NAME KUserFeedbackCore
                      LIB_NAME KUserFeedbackCore
                      DEPS "core network"
                      FILENAME_VAR PRI_FILENAME
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== src/provider/qml/CMakeLists.txt ===
set(provider_qml_srcs
    qmlabstractdatasource.cpp
    qmldatasources.cpp
    qmlplugin.cpp
    qmlpropertyratiosource.cpp
    qmlproviderextension.cpp
    qmlpropertysource.cpp
)

add_library(KUserFeedbackQml SHARED ${provider_qml_srcs})

target_link_libraries(KUserFeedbackQml
    KUserFeedbackCore
    Qt5::Qml
)

install(TARGETS KUserFeedbackQml DESTINATION ${QML_INSTALL_DIR}/org/kde/userfeedback)
install(FILES qmldir DESTINATION ${QML_INSTALL_DIR}/org/kde/userfeedback)

=== src/provider/widgets/CMakeLists.txt ===
set(userfeedback_widgets_srcs
    feedbackconfigdialog.cpp
    feedbackconfigwidget.cpp
    notificationpopup.cpp
    styleinfosource.cpp
    auditlogbrowserdialog.cpp
)

add_library(KUserFeedbackWidgets ${userfeedback_widgets_srcs})
set_target_properties(KUserFeedbackWidgets PROPERTIES
    SOVERSION ${KUSERFEEDBACK_SOVERSION}
    VERSION ${KUSERFEEDBACK_VERSION_STRING}
)
generate_export_header(KUserFeedbackWidgets)
if(TARGET Qt5::Widgets)
    target_link_libraries(KUserFeedbackWidgets PUBLIC Qt5::Widgets KUserFeedbackCore)
else()
    target_link_libraries(KUserFeedbackWidgets PUBLIC ${QT_QTGUI_LIBRARIES} KUserFeedbackCore)
endif()
target_include_directories(KUserFeedbackWidgets PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR}>")
target_include_directories(KUserFeedbackWidgets INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KUserFeedback;${KDE_INSTALL_INCLUDEDIR}>")

ecm_generate_headers(KUserFeedbackWidgets_HEADERS
    HEADER_NAMES
        FeedbackConfigDialog
        FeedbackConfigWidget
        NotificationPopup
        StyleInfoSource
    REQUIRED_HEADERS KUserFeedbackWidgets_HEADERS
)

install(TARGETS KUserFeedbackWidgets EXPORT KUserFeedbackTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
    ${KUserFeedbackWidgets_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/kuserfeedbackwidgets_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KUserFeedback
)

ecm_generate_pri_file(BASE_NAME KUserFeedbackWidgets
                      LIB_NAME KUserFeedbackWidgets
                      DEPS "KUserFeedbackCore widgets"
                      FILENAME_VAR PRI_FILENAME
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== debian/changelog ===
kuserfeedback (1.0.0-3) unstable; urgency=medium

  * Team upload.
  * Build the documentation only in -indep builds:
    - pass -DENABLE_DOCS=OFF to cmake in dh_auto_configure of -arch builds
    - pass -DENABLE_DOCS=ON to cmake in dh_auto_configure of -indep builds
    - move qdoc-qt5 as Build-Depends-Indep
    - drop the -DBUILD_QCH=ON cmake parameter, as it does not exist
  * Remove the unused doxygen build dependency.
  * Remove the unused debian/meta/ stuff.

 -- Pino Toscano <pino@debian.org>  Tue, 27 Oct 2020 21:38:10 +0100

kuserfeedback (1.0.0-2) unstable; urgency=medium

  [ Sandro Knauß ]
  * Add qdoc-qt5 to B-D needed for archs without qtdoc-qt5 dependency
    inside qttools5-dev-tools.

 -- Sandro Knauß <hefee@debian.org>  Thu, 22 Oct 2020 11:02:51 +0200

kuserfeedback (1.0.0-1) unstable; urgency=medium

  [ Scarlett Moore ]
  * Remove libkuserfeedbackcore1.maintscript as this package
    is NEW and will not have dangling maint scripts.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper build dependency to debhelper-compat 13
    - remove debian/compat
  * Bump Standards-Version to 4.5.0, no changes required.
  * Add Salsa CI config with team builder enabled.
  * Update copyright file.
    - Add missing copyright.
    - Add Upstream-name, Upstream-Contact fields.
    - Fix Source to point to invent.kde.org repo.
  * Update Rules file.
    - Fix dh call to use symbols helper and kf5 buildsystem.
    - Remove defunkt qtselect export. Qt4 is no more.
    - Add hardening options to build maint export.
  * Update Maintainer to be debian-qt-kde team.
  * Add myself to uploaders.
  * Fix the control file entries.
    - kuserfeedback-bin: fix Multi-Arch to any, it is binaries.
      Remove section: doc as it is not docs. Fix multi-Arch to same.
      Improve the long description.
    - libkuserfeebackcore1: remove breaks/replace ( neon merge. ).
      Improve long description.
    - libkuserfeebackwidgets: remove breaks/replace ( neon merge. ).
      Improve long description.
    - qml-module-org-kde-userfeedback:
      Improve long description.
    - kuserfeedback-doc:
      Improve long description.
    - kuserfeedback-dev:
      Improve long descriptions.
  * Add VSC git entries.
  * Update homepage links to invent.

  [ Sandro Knauß ]
  * Add Rules-Requires-Root field to control.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Enable running autotests.
  * Update copyright file.
  * kuserfeedback-bin is not Multi-Arch same compatible.
  * Fill upstream metadata.
  * Add symbols files.
  * Add Build-Depends-Package to symbols file.
  * Initial Debian release. (Closes: #970433)
  * Add myself to Uploaders.

 -- Sandro Knauß <hefee@debian.org>  Wed, 16 Sep 2020 12:53:13 +0200

kuserfeedback (1.0.0-0) bionic; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 11 Aug 2019 18:49:14 +0000

=== debian/control ===
Source: kuserfeedback
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Moore <sgmoore@kde.org>, Sandro Knauß <hefee@debian.org>
Build-Depends: bison,
               cmake (>= 3.0~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.51.0~),
               flex,
               libqt5charts5-dev,
               libqt5svg5-dev,
               pkg-kde-tools (>= 0.15.15ubuntu1~),
               qtbase5-dev (>= 5.8.0~),
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev,
               qttools5-dev-tools (>= 5.4),
               xauth,
               xvfb,
Build-Depends-Indep: qdoc-qt5,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://invent.kde.org/libraries/kuserfeedback
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kuserfeedback
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kuserfeedback.git

Package: kuserfeedback-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: user feedback for applications - executables
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the management and analytics applications.

Package: kuserfeedback-dev
Section: libdevel
Architecture: any
Depends: libkuserfeedbackcore1 (= ${binary:Version}),
         libkuserfeedbackwidgets1 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends},
Description: development files for KUserFeedback
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the development header files for kuserfeedback.

Package: kuserfeedback-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: doc
Description: user feedback for applications - documentation
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the documentation for kuserfeedback.

Package: libkuserfeedbackcore1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: kuserfeedback-doc (= ${binary:Version})
Description: user feedback for applications - core library
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the core library for kuserfeedback.

Package: libkuserfeedbackwidgets1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: qml-module-org-kde-userfeedback (= ${binary:Version})
Description: user feedback for applications - widgets library
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the widgets library used by kuserfeedback.

Package: qml-module-org-kde-userfeedback
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: user feedback for applications - QML module
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the QML module for kuserfeedback.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_auto_configure-arch:
	dh_auto_configure -- -DENABLE_DOCS=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- -DENABLE_DOCS=ON

override_dh_auto_test:
	xvfb-run dh_auto_test --no-parallel

## kuserfeedback 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.0)
-project(KUserFeedback VERSION 1.0.0)
+project(KUserFeedback VERSION 1.2.0)
 
 set(POLICY CMP0048 NEW)
 if(POLICY CMP0053)
@@ -25,7 +25,7 @@
 set(CMAKE_AUTOUIC ON)
 set(CMAKE_AUTORCC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 
 include(KDEInstallDirs)
 include(KDECMakeSettings)
@@ -39,6 +39,12 @@
 include(FeatureSummary)
 include(GenerateExportHeader)
 
+if(QT_MAJOR_VERSION STREQUAL "5")
+    find_package(Qt5 CONFIG OPTIONAL_COMPONENTS DocTools)
+else()
+    find_package(Qt6 CONFIG OPTIONAL_COMPONENTS ToolsTools)
+endif()
+
 ecm_setup_version(PROJECT
     VARIABLE_PREFIX KUSERFEEDBACK
     VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kuserfeedback_version.h"
@@ -48,16 +54,16 @@
 # Dependencies
 #
 
-find_package(Qt5 5.4 NO_MODULE REQUIRED COMPONENTS Core Network)
-find_package(Qt5 NO_MODULE QUIET OPTIONAL_COMPONENTS Widgets Charts Test Qml Svg PrintSupport)
+find_package(Qt${QT_MAJOR_VERSION} 5.4 NO_MODULE REQUIRED COMPONENTS Core Network)
+find_package(Qt${QT_MAJOR_VERSION} NO_MODULE QUIET OPTIONAL_COMPONENTS Widgets Charts Test Qml Svg PrintSupport)
 find_package(QmlLint)
 if (NOT CMAKE_CROSSCOMPILING)
-    find_package(Qt5 NO_MODULE QUIET OPTIONAL_COMPONENTS Help)
+    find_package(Qt${QT_MAJOR_VERSION} NO_MODULE QUIET OPTIONAL_COMPONENTS Help)
 endif()
 
-set_package_properties(Qt5 PROPERTIES URL "http://qt-project.org/")
-set_package_properties(Qt5Widgets PROPERTIES TYPE RECOMMENDED PURPOSE "Required for feedback configuration and notification widgets.")
-set_package_properties(Qt5Charts PROPERTIES TYPE RECOMMENDED PURPOSE "Required for UserFeedbackConsole.")
+set_package_properties(Qt${QT_MAJOR_VERSION} PROPERTIES URL "http://qt-project.org/")
+set_package_properties(Qt${QT_MAJOR_VERSION}Widgets PROPERTIES TYPE RECOMMENDED PURPOSE "Required for feedback configuration and notification widgets.")
+set_package_properties(Qt${QT_MAJOR_VERSION}Charts PROPERTIES TYPE RECOMMENDED PURPOSE "Required for UserFeedbackConsole.")
 
 # debug suffixes for qmake compatibility
 if(WIN32)
@@ -113,8 +119,15 @@
 # CMake package config file generation
 #
 include(CMakePackageConfigHelpers)
+
+if (${QT_MAJOR_VERSION} GREATER_EQUAL 6)
+    set(_CONFIG_CMAKE_IN "KUserFeedbackConfig-Qt6.cmake.in")
+else()
+    set(_CONFIG_CMAKE_IN "KUserFeedbackConfig-Qt5.cmake.in")
+endif()
+
 configure_package_config_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/KUserFeedbackConfig.cmake.in
+    ${CMAKE_CURRENT_SOURCE_DIR}/${_CONFIG_CMAKE_IN}
     ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedbackConfig.cmake
     INSTALL_DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback
     PATH_VARS KDE_INSTALL_INCLUDEDIR
@@ -127,7 +140,12 @@
 )
 
 install(EXPORT KUserFeedbackTargets DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback FILE KUserFeedbackTarget.cmake)
-install(FILES org_kde_UserFeedback.categories DESTINATION ${KDE_INSTALL_CONFDIR})
+
+if (ECM_VERSION VERSION_GREATER "5.58.0")
+    install(FILES org_kde_UserFeedback.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})
+else()
+    install(FILES org_kde_UserFeedback.categories DESTINATION ${KDE_INSTALL_CONFDIR})
+endif()
 
 feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== autotests/CMakeLists.txt ===
configure_file(test-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/test-config.h)
if(TARGET KUserFeedbackConsole)
add_library(KUserFeedbackTestUtils STATIC
    servercontroller.cpp
)
target_link_libraries(KUserFeedbackTestUtils LINK_PUBLIC Qt${QT_MAJOR_VERSION}::Test KUserFeedbackConsole)
endif()

function(uf_add_test _file)
    get_filename_component(_name ${_file} NAME_WE)
    add_executable(${_name} ${_file})
    target_link_libraries(${_name} Qt${QT_MAJOR_VERSION}::Test ${ARGN})
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

uf_add_test(datasourcetest.cpp KUserFeedbackCore Qt${QT_MAJOR_VERSION}::Gui) # needs Gui for ScreenInfoSource to work
uf_add_test(openglinfosourcetest.cpp KUserFeedbackCore Qt${QT_MAJOR_VERSION}::Gui)
uf_add_test(providertest.cpp KUserFeedbackCore Qt${QT_MAJOR_VERSION}::Gui)
uf_add_test(selectionratiosourcetest.cpp KUserFeedbackCore Qt${QT_MAJOR_VERSION}::Gui)
uf_add_test(surveyprovidertest.cpp KUserFeedbackCore)

uf_add_test(feedbackconfigtest.cpp KUserFeedbackWidgets)

if(HAVE_SURVEY_TARGET_EXPRESSIONS)
    uf_add_test(surveytargetexpressiontest.cpp KUserFeedbackCommon)
endif()

if(TARGET KUserFeedbackConsole)
    uf_add_test(producttest.cpp KUserFeedbackConsole)
    uf_add_test(schematemplatetest.cpp KUserFeedbackConsole)
    uf_add_test(sampletest.cpp KUserFeedbackConsole)
    uf_add_test(serverinfotest.cpp KUserFeedbackConsole)

    uf_add_test(schemamodeltest.cpp KUserFeedbackTestUtils)
    uf_add_test(datamodeltest.cpp KUserFeedbackTestUtils)
    uf_add_test(timeaggregationmodeltest.cpp KUserFeedbackTestUtils)
    uf_add_test(categoryaggregationmodeltest.cpp KUserFeedbackTestUtils)
    uf_add_test(numericaggregationmodeltest.cpp KUserFeedbackTestUtils)
    uf_add_test(ratiosetaggregationmodeltest.cpp KUserFeedbackTestUtils)
endif()

if(ENABLE_PHP)
    list(FIND PHP_MODULES "PDO" _has_pdo)
    if(TARGET KUserFeedbackConsole AND _has_pdo GREATER -1)
        uf_add_test(productapitest.cpp KUserFeedbackTestUtils)
        uf_add_test(productmodeltest.cpp KUserFeedbackTestUtils)
        uf_add_test(surveyapitest.cpp KUserFeedbackTestUtils)
        uf_add_test(submittest.cpp KUserFeedbackTestUtils KUserFeedbackCore Qt${QT_MAJOR_VERSION}::Gui)
    endif()

    set(php_test_srcs
        utilstest.php
        schemaentrytest.php
        schemaentryelementtest.php
        producttest.php
        sampletest.php
        surveytest.php
        aggregationtest.php
    )

    php_lint(abstractdatastoretest.php)
    php_lint(${php_test_srcs})
    if(PhpUnit_FOUND)
        foreach(_php_test ${php_test_srcs})
            add_test(NAME ${_php_test} COMMAND ${PHPUNIT_EXECUTABLE} ${_php_test} WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
        endforeach()
    endif()
endif()

=== docs/CMakeLists.txt ===
if(QT_MAJOR_VERSION STREQUAL "5")
    query_qmake(QT_INSTALL_DOCS "QT_INSTALL_DOCS")
    query_qmake(QT_INSTALL_DATA "QT_INSTALL_DATA")
    find_file(QDOC_TEMPLATE global/qt-html-templates-offline.qdocconf
        HINTS ${QT_INSTALL_DOCS}
        HINTS ${QT_INSTALL_DATA}
        HINTS ${QT_INSTALL_DATA}/doc
    )
elseif(QT_MAJOR_VERSION STREQUAL "6")
    find_file(QDOC_TEMPLATE global/qt-html-templates-offline.qdocconf
        HINTS ${QT6_INSTALL_PREFIX}/${QT6_INSTALL_DOCS}
    )
endif()

get_filename_component(QDOC_TEMPLATE_DIR ${QDOC_TEMPLATE} DIRECTORY)
if(NOT QDOC_TEMPLATE_DIR)
    message(STATUS "Could not build .qch because the qdoc template directory could not be found")
endif()

function(_qdoc_status_report)
    message(STATUS "Unable to build .qch user manual:")

    if(TARGET Qt${QT_MAJOR_VERSION}::qdoc)
        get_property(_path TARGET Qt${QT_MAJOR_VERSION}::qdoc PROPERTY LOCATION)
        message(STATUS "qdoc executable: ${_path}")
    else()
        message(STATUS "qdoc executable not found")
    endif()

    if(TARGET Qt${QT_MAJOR_VERSION}::qhelpgenerator)
        get_property(_path TARGET Qt${QT_MAJOR_VERSION}::qhelpgenerator PROPERTY LOCATION)
        message(STATUS "qhelpgenerator executable: ${_path}")
    else()
        message(STATUS "qhelpgenerator not found")
    endif()
endfunction()

set(_qdoc_available FALSE)
if(QDOC_TEMPLATE_DIR AND TARGET Qt${QT_MAJOR_VERSION}::qdoc AND TARGET Qt${QT_MAJOR_VERSION}::qhelpgenerator)
    set(_qdoc_available TRUE)
endif()

# If qdoc and qhelpgenerator are found build .qch
if(NOT _qdoc_available)
    _qdoc_status_report()
else()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/user-feedback-manual.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/user-feedback-manual.qdocconf)
    file(GLOB_RECURSE _qdoc_srcs ${CMAKE_CURRENT_SOURCE_DIR} "*.qdoc")
    set(_qdoc_output_dir ${CMAKE_CURRENT_BINARY_DIR}/manual)
    add_custom_command(
        OUTPUT ${_qdoc_output_dir}/user-feedback-manual.qhp
        COMMAND Qt${QT_MAJOR_VERSION}::qdoc
            --outputdir ${_qdoc_output_dir}
            ${CMAKE_CURRENT_BINARY_DIR}/user-feedback-manual.qdocconf
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/user-feedback-manual.qdocconf ${_qdoc_srcs}
    )
    add_custom_command(
        OUTPUT ${_qdoc_output_dir}/user-feedback-manual.qch
        COMMAND Qt${QT_MAJOR_VERSION}::qhelpgenerator ${_qdoc_output_dir}/user-feedback-manual.qhp
        DEPENDS ${_qdoc_output_dir}/user-feedback-manual.qhp
    )
    add_custom_target(user_feedback_manual_qch ALL DEPENDS ${_qdoc_output_dir}/user-feedback-manual.qch)
    install(FILES ${_qdoc_output_dir}/user-feedback-manual.qch DESTINATION ${KDE_INSTALL_DATAROOTDIR}/KDE/UserFeedbackConsole)
endif()

# If qcollectiongenerator is found build .qhc
if(NOT TARGET Qt${QT_MAJOR_VERSION}::qcollectiongenerator OR NOT _qdoc_available)
    message(STATUS "Unable to build .qhc user manual:")
    if(TARGET Qt${QT_MAJOR_VERSION}::qcollectiongenerator)
        get_property(_path TARGET Qt${QT_MAJOR_VERSION}::qcollectiongenerator PROPERTY LOCATION)
        message(STATUS "qcollectiongenerator executable: ${_path}")
    else()
        message(STATUS "qcollectiongenerator not found")
    endif()

    _qdoc_status_report()
else()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/user-feedback.qhcp.in ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhcp)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/manual/user-feedback-manual.qch ${CMAKE_CURRENT_BINARY_DIR}
        COMMAND Qt${QT_MAJOR_VERSION}::qcollectiongenerator ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhcp -o ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc
        DEPENDS
            ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhcp
            user_feedback_manual_qch
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    )
    add_custom_target(user_feedback_qhc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/user-feedback.qhc DESTINATION ${KDE_INSTALL_DATAROOTDIR}/KDE/UserFeedbackConsole)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,9 @@
 endif()
 
 list(FIND CMAKE_CXX_COMPILE_FEATURES cxx_generic_lambdas has_generic_lambdas)
-if(Qt5Charts_FOUND AND Qt5Svg_FOUND AND Qt5PrintSupport_FOUND AND NOT has_generic_lambdas LESS 0 AND NOT Qt5Core_VERSION VERSION_LESS 5.8)
+if(((Qt5Charts_FOUND AND Qt5Svg_FOUND AND Qt5PrintSupport_FOUND AND NOT Qt5Core_VERSION VERSION_LESS 5.8)
+        OR (Qt6Charts_FOUND AND Qt6Svg_FOUND AND Qt6PrintSupport_FOUND))
+    AND NOT has_generic_lambdas LESS 0 )
     if (ENABLE_CONSOLE)
         add_subdirectory(console)
     endif()

=== src/common/CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,10 @@
 if(HAVE_SURVEY_TARGET_EXPRESSIONS)
 
 if (CMAKE_VERSION VERSION_LESS 3.5.0)
-    set(_flex_opts COMPILE_FLAGS --header-file=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
+    set(_flex_opts COMPILE_FLAGS --nounistd --header-file=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
     set(_bison_opts COMPILE_FLAGS --defines=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.h)
 else()
-    set(_flex_opts DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
+    set(_flex_opts COMPILE_FLAGS --nounistd DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
     set(_bison_opts DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.h)
 endif()
 
@@ -32,6 +32,8 @@
     ${BISON_surveytargetexpressionparser_OUTPUTS}
     ${FLEX_surveytargetexpressionscanner_OUTPUTS}
 )
+# Needed to link this static lib to shared libs
+set_property(TARGET KUserFeedbackCommon PROPERTY POSITION_INDEPENDENT_CODE ON)
 
 if (NOT BUILD_SHARED_LIBS)
     install(TARGETS KUserFeedbackCommon
@@ -39,4 +41,4 @@
 endif()
 
 target_include_directories(KUserFeedbackCommon PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..>")
-target_link_libraries(KUserFeedbackCommon LINK_PRIVATE Qt5::Core)
+target_link_libraries(KUserFeedbackCommon PUBLIC Qt${QT_MAJOR_VERSION}::Core)

=== src/console/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 )
 
 add_library(KUserFeedbackConsole STATIC ${console_lib_srcs})
-target_link_libraries(KUserFeedbackConsole Qt5::Network)
+target_link_libraries(KUserFeedbackConsole Qt${QT_MAJOR_VERSION}::Network)
 target_include_directories(KUserFeedbackConsole PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..>")
 target_compile_features(KUserFeedbackConsole PRIVATE cxx_generic_lambdas)
 target_compile_definitions(KUserFeedbackConsole PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x050600 QT_DEPRECATED_WARNINGS)
@@ -81,11 +81,11 @@
 target_compile_features(KUserFeedbackConsoleApplication PRIVATE cxx_generic_lambdas)
 set_target_properties(KUserFeedbackConsoleApplication PROPERTIES OUTPUT_NAME UserFeedbackConsole)
 target_link_libraries(KUserFeedbackConsoleApplication
-    Qt5::Widgets
-    Qt5::Network
-    Qt5::Charts
-    Qt5::PrintSupport
-    Qt5::Svg
+    Qt${QT_MAJOR_VERSION}::Widgets
+    Qt${QT_MAJOR_VERSION}::Network
+    Qt${QT_MAJOR_VERSION}::Charts
+    Qt${QT_MAJOR_VERSION}::PrintSupport
+    Qt${QT_MAJOR_VERSION}::Svg
     KUserFeedbackWidgets
     KUserFeedbackConsole
     KUserFeedbackCommon
@@ -93,5 +93,6 @@
 
 install(TARGETS KUserFeedbackConsoleApplication ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
 if(UNIX AND NOT APPLE)
-    install(FILES UserFeedbackConsole.desktop DESTINATION ${KDE_INSTALL_APPDIR})
+    install(FILES org.kde.kuserfeedback-console.desktop DESTINATION ${KDE_INSTALL_APPDIR})
+    install(FILES org.kde.kuserfeedback-console.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
 endif()

=== src/provider/core/CMakeLists.txt ===
--- 
+++ 
@@ -25,11 +25,11 @@
 add_library(KUserFeedbackCore ${userfeedback_core_srcs})
 set_target_properties(KUserFeedbackCore PROPERTIES
     SOVERSION ${KUSERFEEDBACK_SOVERSION}
-    VERSION ${KUSERFEEDBACK_VERSION_STRING}
+    VERSION ${KUSERFEEDBACK_VERSION}
 )
 generate_export_header(KUserFeedbackCore)
 
-target_link_libraries(KUserFeedbackCore PUBLIC Qt5::Core PRIVATE Qt5::Gui Qt5::Network)
+target_link_libraries(KUserFeedbackCore PUBLIC Qt${QT_MAJOR_VERSION}::Core PRIVATE Qt${QT_MAJOR_VERSION}::Gui Qt${QT_MAJOR_VERSION}::Network)
 if(ANDROID)
     target_link_libraries(KUserFeedbackCore PRIVATE GLESv2)
 endif()

=== src/provider/qml/CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 
 target_link_libraries(KUserFeedbackQml
     KUserFeedbackCore
-    Qt5::Qml
+    Qt${QT_MAJOR_VERSION}::Qml
 )
 
-install(TARGETS KUserFeedbackQml DESTINATION ${QML_INSTALL_DIR}/org/kde/userfeedback)
-install(FILES qmldir DESTINATION ${QML_INSTALL_DIR}/org/kde/userfeedback)
+install(TARGETS KUserFeedbackQml DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/userfeedback)
+install(FILES qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/userfeedback)

=== src/provider/widgets/CMakeLists.txt ===
--- 
+++ 
@@ -9,11 +9,11 @@
 add_library(KUserFeedbackWidgets ${userfeedback_widgets_srcs})
 set_target_properties(KUserFeedbackWidgets PROPERTIES
     SOVERSION ${KUSERFEEDBACK_SOVERSION}
-    VERSION ${KUSERFEEDBACK_VERSION_STRING}
+    VERSION ${KUSERFEEDBACK_VERSION}
 )
 generate_export_header(KUserFeedbackWidgets)
-if(TARGET Qt5::Widgets)
-    target_link_libraries(KUserFeedbackWidgets PUBLIC Qt5::Widgets KUserFeedbackCore)
+if(TARGET Qt${QT_MAJOR_VERSION}::Widgets)
+    target_link_libraries(KUserFeedbackWidgets PUBLIC Qt${QT_MAJOR_VERSION}::Widgets KUserFeedbackCore)
 else()
     target_link_libraries(KUserFeedbackWidgets PUBLIC ${QT_QTGUI_LIBRARIES} KUserFeedbackCore)
 endif()

=== debian/changelog ===
kuserfeedback (1.2.0-2) unstable; urgency=medium

  * Team upload.
  * Bump the reference version used to cleanup the old
    /etc/xdg/org_kde_UserFeedback.categories to the same version of this
    changelog entry, as versions in the past do not work when upgrading.
  * Mark the xauth, and xvfb build dependencies as !nocheck, as they are needed
    only during dh_auto_test.

 -- Pino Toscano <pino@debian.org>  Wed, 23 Feb 2022 07:47:33 +0100

kuserfeedback (1.2.0-1) unstable; urgency=medium

  * Update upstream signing key for Jonathan Ridell.
  * New upstream release (1.2.0).
  * Added myself to the uploaders.
  * Update the list of installed files, gracefully handle move of
    org_kde_UserFeedback.categories from /etc to /usr.
  * Update symbols from build for 1.2.0.
  * Refresh copyright information.
  * Bump Standards-Version to 4.6.0, no changes required.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 06 Feb 2022 23:45:13 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: libs
 Priority: optional
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Scarlett Moore <sgmoore@kde.org>, Sandro Knauß <hefee@debian.org>
+Uploaders: Aurélien COUDERC <coucouf@debian.org>,
+           Scarlett Moore <sgmoore@kde.org>, Sandro Knauß <hefee@debian.org>,
 Build-Depends: bison,
                cmake (>= 3.0~),
                debhelper-compat (= 13),
@@ -16,11 +17,11 @@
                qtdeclarative5-dev-tools,
                qttools5-dev,
                qttools5-dev-tools (>= 5.4),
-               xauth,
-               xvfb,
-Build-Depends-Indep: qdoc-qt5,
+               xauth <!nocheck>,
+               xvfb <!nocheck>,
+Build-Depends-Indep: qdoc-qt5
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://invent.kde.org/libraries/kuserfeedback
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kuserfeedback
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kuserfeedback.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_auto_configure-arch:
	dh_auto_configure -- -DENABLE_DOCS=OFF -DQT_MAJOR_VERSION=5

override_dh_auto_configure-indep:
	dh_auto_configure -- -DENABLE_DOCS=ON -DQT_MAJOR_VERSION=5

override_dh_auto_test:
	xvfb-run dh_auto_test --no-parallel
